
% order of Farrow arm filters
K = 6;

% polynomial approximation order
L = 5;

N = 64;

% design the oversampled filter
h = remez((K+1)*N,[0 1/N 3/N 1],[1 1 0 0]);

% create the piecewise polynomial approximation to the desired filter
P = [];
hh = [];
for k=1:K+1,
  x = [0:N]/N;
  y = h((k-1)*N+1:k*N+1);
  p = polyfit(x,y,L);
  P = [P; p];
  plot(x,y);
  hold on;
  y = polyval(p,x);
  plot(x,y,'g');
  hold off;
  hh = [hh y(1:N)];
  pause;
end;
plot(h);
hold on;
plot(hh,'g');
hold off;
pause;
H = freqz(h);
HH = freqz(hh);
plot(20*log10(abs(H)));
hold on;
plot(20*log10(abs(HH)),'g');
hold off;
pause;

% evaluate using horner
hhh = zeros(1,N*(K+1));
for n=1:N,
  d = (n-1)/N*ones(1,K+1);
  h0 = zeros(1,K+1);
  for l=1:L+1,
    h0 = d.*h0 + P(:,l).';
  end;
  hhh(n:N:N*(K+1)) = h0;
end;
plot(hh);
hold on;
plot(hhh,'g');
hold off;
